Package com.emc.documentum.rest.dfc

# Interface AuditManager

public interface AuditManager

- ## Method Summary

  Modifier and Type
  Method
  Description
  `AuditPolicy`
  `createAuditPolicy(AuditPolicy auditPolicy)`
  Create an audit policy for purging audit trails.
  `void`
  `createSecurityAuditEntry(com.documentum.fc.client.IDfSession session, Boolean isLoginEvent, com.emc.documentum.rest.audit.SecurityAuditEntry securityAuditEntry)`
  `void`
  `deleteAuditPolicy(String policyId)`
  Delete certain audit policy by policy object id.
  `List<String>`
  `getAllEvents()`
  Get all available events in whole repository, including system events and application events.
  `List<String>`
  `getApplicableEvents(String objectId)`
  Get all available events for object instance, including system events and application events.
  `List<String>`
  `getApplicableEventsForType(String typeName)`
  Get all available events for certain type, including system events and application events.
  `AuditEvent`
  `getAuditEvent(String auditEventId)`
  Get single audit event by id.
  `AuditPolicy`
  `getAuditPolicy(String policyId)`
  Get certain audit policy by policy object id.
  `AuditTrail`
  `getAuditTrail(String auditTrailId, AttributeView attributeView)`
  Get audit trail with id.
  `void`
  `purgeAuditTrail(String auditTrailId, boolean isTraceable)`
  Purge an audit trail by id.
  `AuditEvent`
  `registerEventForObject(String objectId, AuditEvent auditEvent)`
  Register an audit event for object instance by id.
  `AuditEvent`
  `registerEventForType(String typeName, AuditEvent auditEvent)`
  Register an audit event for type by name.
  `AuditEvent`
  `registerEventForWholeRepository(AuditEvent auditEvent)`
  Register an audit event for whole repository.
  `void`
  `unregisterAllEventsForObject(String objectId)`
  Unregister all events that registered on certain object instance.
  `void`
  `unregisterAllEventsForType(String typeName)`
  Unregister all events that registered on certain type.
  `void`
  `unregisterAllEventsForWholeRepository()`
  Unregister all events that registered on whole repository.
  `void`
  `unregisterEvent(String auditEventId)`
  Unregister certain audit event by id of event instance.
  `void`
  `unregisterEventForObject(String objectId, String event, String lifecycleId, String lifecycleState)`
  Unregister certain event that registered on object.
  `void`
  `unregisterEventForType(String typeName, String event, String lifecycleId, String lifecycleState, String controllingApp)`
  Unregister certain event that registered on type.
  `void`
  `unregisterEventsForWholeRepository(String event)`
  Unregister certain event that registered on repository.
  `AuditPolicy`
  `updateAuditPolicy(String auditPolicyId, AuditPolicy newAuditPolicy)`
  Update certain policy by policy object id.

- ## Method Details

  - ### purgeAuditTrail

    void purgeAuditTrail(String auditTrailId, boolean isTraceable) throws com.documentum.fc.common.DfException
    Purge an audit trail by id.
    Parameters:
      `auditTrailId` - r_object_id of an audit trail object.
      `isTraceable` - if true, this audit trail is not really purged and audit trails related with it will be recorded. Default value is false.
    Throws:
      `com.documentum.fc.common.DfException` - fc exception during operation.

  - ### getAuditTrail

    AuditTrail getAuditTrail(String auditTrailId, AttributeView attributeView) throws com.documentum.fc.common.DfException
    Get audit trail with id.
    Parameters:
      `auditTrailId` - r_object_id of audit trail object.
      `attributeView` - attribute view on the result.
    Returns:
      audit trail object.
    Throws:
      `com.documentum.fc.common.DfException` - fc exception during operation.

  - ### getAllEvents

    List<String> getAllEvents() throws com.documentum.fc.common.DfException
    Get all available events in whole repository, including system events and application events.
    Returns:
      audit event list object.
    Throws:
      `com.documentum.fc.common.DfException` - fc exception during operation.

  - ### getApplicableEvents

    List<String> getApplicableEvents(String objectId) throws com.documentum.fc.common.DfException
    Get all available events for object instance, including system events and application events. If objectId is null, this function behaves as same as getAllEvents().
    Parameters:
      `objectId` - r_object_id of object instance.
    Returns:
      audit event list object.
    Throws:
      `com.documentum.fc.common.DfException` - fc exception during operation.

  - ### getApplicableEventsForType

    List<String> getApplicableEventsForType(String typeName) throws com.documentum.fc.common.DfException
    Get all available events for certain type, including system events and application events.
    Parameters:
      `typeName` - name of certain dm_type object
    Returns:
      audit event list object.
    Throws:
      `com.documentum.fc.common.DfException` - fc exception during operation.

  - ### getAuditEvent

    AuditEvent getAuditEvent(String auditEventId) throws com.documentum.fc.common.DfException
    Get single audit event by id.
    Parameters:
      `auditEventId` - r_object_id of audit event object.
    Returns:
      audit event object.
    Throws:
      `com.documentum.fc.common.DfException` - fc exception during operation.

  - ### registerEventForWholeRepository

    AuditEvent registerEventForWholeRepository(AuditEvent auditEvent) throws com.documentum.fc.common.DfException
    Register an audit event for whole repository.
    Parameters:
      `auditEvent` - audit event object that will be registered on repository.
    Returns:
      registered audit event object.
    Throws:
      `com.documentum.fc.common.DfException` - fc exception during operation.

  - ### registerEventForObject

    AuditEvent registerEventForObject(String objectId, AuditEvent auditEvent) throws com.documentum.fc.common.DfException
    Register an audit event for object instance by id.
    Parameters:
      `objectId` - r_object_id of object instance.
      `auditEvent` - audit event object that will be registered for object instance.
    Returns:
      registered audit event object.
    Throws:
      `com.documentum.fc.common.DfException` - fc exception during operation.

  - ### registerEventForType

    AuditEvent registerEventForType(String typeName, AuditEvent auditEvent) throws com.documentum.fc.common.DfException
    Register an audit event for type by name.
    Parameters:
      `typeName` - name of certain type.
      `auditEvent` - audit event object that will be registered for type.
    Returns:
      registered audit event object.
    Throws:
      `com.documentum.fc.common.DfException` - fc exception during operation.

  - ### unregisterAllEventsForWholeRepository

    void unregisterAllEventsForWholeRepository() throws com.documentum.fc.common.DfException
    Unregister all events that registered on whole repository.
    Throws:
      `com.documentum.fc.common.DfException` - fc exception during operation.

  - ### unregisterAllEventsForObject

    void unregisterAllEventsForObject(String objectId) throws com.documentum.fc.common.DfException
    Unregister all events that registered on certain object instance.
    Parameters:
      `objectId` - r_object_id of object instance.
    Throws:
      `com.documentum.fc.common.DfException` - fc exception during operation.

  - ### unregisterAllEventsForType

    void unregisterAllEventsForType(String typeName) throws com.documentum.fc.common.DfException
    Unregister all events that registered on certain type.
    Parameters:
      `typeName` - name of certain type.
    Throws:
      `com.documentum.fc.common.DfException` - fc exception during operation.

  - ### unregisterEventsForWholeRepository

    void unregisterEventsForWholeRepository(String event) throws com.documentum.fc.common.DfException
    Unregister certain event that registered on repository.
    Parameters:
      `event` - name of audit event that needs to unregister.
    Throws:
      `com.documentum.fc.common.DfException` - fc exception during operation.

  - ### unregisterEventForObject

    void unregisterEventForObject(String objectId, String event, String lifecycleId, String lifecycleState) throws com.documentum.fc.common.DfException
    Unregister certain event that registered on object.
    Parameters:
      `objectId` - r_object_id of object instance.
      `event` - name of audit event that needs to unregister.
      `lifecycleId` - r_object_id of lifecycle object.
      `lifecycleState` - state of lifecycle object.
    Throws:
      `com.documentum.fc.common.DfException` - fc exception during operation.

  - ### unregisterEventForType

    void unregisterEventForType(String typeName, String event, String lifecycleId, String lifecycleState, String controllingApp) throws com.documentum.fc.common.DfException
    Unregister certain event that registered on type.
    Parameters:
      `typeName` - name of type.
      `event` - name of audit event that needs to unregister.
      `lifecycleId` - r_object_id of lifecycle object.
      `lifecycleState` - state of lifecycle object.
      `controllingApp` - alias of controlling application that defined by application self, always lower case.
    Throws:
      `com.documentum.fc.common.DfException` - fc exception during operation.

  - ### unregisterEvent

    void unregisterEvent(String auditEventId) throws com.documentum.fc.common.DfException
    Unregister certain audit event by id of event instance.
    Parameters:
      `auditEventId` - r_object_id of audit event.
    Throws:
      `com.documentum.fc.common.DfException` - fc exception during operation.

  - ### createAuditPolicy

    AuditPolicy createAuditPolicy(AuditPolicy auditPolicy) throws com.documentum.fc.common.DfException
    Create an audit policy for purging audit trails. Only installer of Content Server has this privilege, i.e., Administrator.
    Parameters:
      `auditPolicy` - detail policy that defines criterion of purging audit trails.
    Returns:
      created audit policy for purging.
    Throws:
      `com.documentum.fc.common.DfException` - fc exception during operation.

  - ### getAuditPolicy

    AuditPolicy getAuditPolicy(String policyId) throws com.documentum.fc.common.DfException
    Get certain audit policy by policy object id.
    Parameters:
      `policyId` - r_object_id of audit policy instance.
    Returns:
      audit policy of certain id.
    Throws:
      `com.documentum.fc.common.DfException` - fc exception during operation.

  - ### deleteAuditPolicy

    void deleteAuditPolicy(String policyId) throws com.documentum.fc.common.DfException
    Delete certain audit policy by policy object id.
    Parameters:
      `policyId` - r_object_id of audit policy instance.
    Throws:
      `com.documentum.fc.common.DfException` - fc exception during operation.

  - ### updateAuditPolicy

    AuditPolicy updateAuditPolicy(String auditPolicyId, AuditPolicy newAuditPolicy) throws com.documentum.fc.common.DfException
    Update certain policy by policy object id.
    Parameters:
      `auditPolicyId` - r_object_id of audit policy instance.
      `newAuditPolicy` - audit policy contains attributes needs to be updated.
    Returns:
      updated audit policy.
    Throws:
      `com.documentum.fc.common.DfException` - fc exception during operation.

  - ### createSecurityAuditEntry

    void createSecurityAuditEntry(com.documentum.fc.client.IDfSession session, Boolean isLoginEvent, com.emc.documentum.rest.audit.SecurityAuditEntry securityAuditEntry) throws com.documentum.fc.common.DfException
    Parameters:
      `session` - Documentum DFC Session
      `securityAuditEntry` - SecurityAuditEntry object which hold the login/logout information needed for logging
    Throws:
      `com.documentum.fc.common.DfException` - fc exception during operation.